//
// Module: BadPixelCorrector
// Author: Hassan Siddiqui
//
// Description: 
//
// Point source implementation of an Encircled Energy Corrector class
//
// Modifications: See ChangeLog
// 
// $Id: BadPixelCorrector.h,v 1.4 2011/09/29 15:07:22 rsaxton Exp $

#ifndef BadPixelCorrector_H
#define BadPixelCorrector_H

/* General */

/* SAS-specific */

/* Local */
#include "BpCorrector.h"
#include "PsfModel.h"
#include "BadPixPSFCorrector.h"
#include "MissingPixCorrector.h"

class BadPixelCorrector : public BpCorrector
{
public:

  /* Constructor */
  BadPixelCorrector(const string & eventFile, unsigned eefactor, 
                           PsfModel * psf, unsigned long flags,
                           unsigned long ccdmask);

  /* Destructor */
  ~BadPixelCorrector();

  vector<double> TotalFactor(const vector<double> & energyVector) const;

  int totalPixels() const;

private:

  /* Make a temporary file for the bad columns */
  DataSet * createTempBadColFile(const string & badpixContainer, 
                                 const string & bctempfile, 
                                 unsigned long flags) const;
  
  /* Add value to vector if not already present */
  bool checkAdd(vector<int16> rawx, int16 value, bool ignoreEdgePixels) const;

  /* Member */
  vector<MissingPixCorrector *> _bpcorr;

  DataSet * _bcset;

 /* Set the temp filename for bad column data */
  string bctempfile; 

};

#endif
